import numpy as np


def k_means_classify(data, cookbook):
 
    sq_dist = ((data[:,None,:] - cookbook[None,:,:])**2.).sum(axis=-1)
    indices = sq_dist.argmin(-1)

    return indices


def k_means_learn(data, cookbook):
    
    indices = k_means_classify(data, cookbook)
    
    new_cookbook = np.empty_like(cookbook)
    for idx in xrange(cookbook.shape[0]):
        cluster = data[indices==idx,:]
        new_cookbook[idx,:] = cluster.mean(axis=0)
    
    return new_cookbook


if __name__ == '__main__':
    k, dim = 10, 5
    
    cookbook = np.random.randn(k, dim)
    data = np.random.randn(1000, dim) * 4
    
    for t in xrange(20):
        print '---', t
        cookbook = k_means_learn(data, cookbook)

    # 4.02 sec
    # 0.46 sec
