import numpy as np


def k_means_classify(data, cookbook):
    
    indices = np.empty((data.shape[0],), dtype=int)
    
    for row_idx, row in enumerate(data):
        
        # Look for cookbook entry with shortest distance.
        min_dist = np.inf
        closest_idx = -1
        for vect_idx, vect in enumerate(cookbook):
            dist = np.linalg.norm(row-vect, 2)
            if dist < min_dist:
                min_dist = dist
                closest_idx = vect_idx
    
        indices[row_idx] = closest_idx

    return indices


def k_means_learn(data, cookbook):
    
    indices = k_means_classify(data, cookbook)
    
    new_cookbook = np.empty_like(cookbook)
    for idx in xrange(cookbook.shape[0]):
        cluster = data[indices==idx,:]
        new_cookbook[idx,:] = cluster.mean(axis=0)
    
    return new_cookbook


if __name__ == '__main__':
    np.seterr(all='raise')
    k, dim = 10, 5
    
    cookbook = np.random.randn(k, dim)
    data = np.random.randn(1000, dim) * 4
    
    for t in xrange(20):
        print '---', t
        cookbook = k_means_learn(data, cookbook)

    # 4.02 sec
