
def k_means_classify_fast(data, cookbook):
    
    indices = np.empty((data.shape[0],), dtype=int)
    
    for row_idx, row in enumerate(data):
        
        # Look for cookbook entry with shortest distance.
        squared_distances = ((row-cookbook)**2.).sum(axis=-1)
        closest_idx = squared_distances.argmin()
    
        indices[row_idx] = closest_idx

    return indices


def k_means_classify_faster(data, cookbook):
    # 10x improvement
    
    sq_dist = ((data[:,None,:] - cookbook[None,:,:])**2.).sum(axis=-1)
    indices = sq_dist.argmin(-1)

    return indices

